/****************************************************************************/
/**  Routine zum Herstellen von Verbindungen zu Unix-Sockets               **/
/**                                                                        **/
/**  Jochen Sarrazin, DG6VJ        <sarrazin@muenster.de>                  **/
/****************************************************************************/


#include <sys/types.h>
#include <sys/socket.h>
#include <linux/in.h>
#include <stdio.h>
#include <stdlib.h>


/* Macht ein Connect zum angegebenen Port auf der Maschine mit der bergebenen Adresse
 * und gibt den File-Descriptor zurck, oder -1, wenn ein Fehler aufgetreten ist.
 */
int make_connect(unsigned short int port, unsigned long int addr)
{
  struct sockaddr_in sock_addr;
  int sock_fd;

  /* Socket ffnen */
  if ((sock_fd = socket(AF_INET,SOCK_STREAM,0)) == -1) return(-1);

  /* Adressen fr die Connect-Geschichte festlegen */
  sock_addr.sin_family = AF_INET;
  sock_addr.sin_port = htons(port);
  sock_addr.sin_addr.s_addr = addr;

  /* Und jetzt connecten */
  if (connect(sock_fd,(struct sockaddr *)&sock_addr,sizeof(struct sockaddr)) != 0) return(-1);
  
  return(sock_fd);
}



/* Das Hauptprogramm connectet, gibt die erste Zeile auf dem Bildschirm
 * aus, und disconnected wieder.
 */
int main()
{
  char str[100];
  int count;
  int fd;

  if ((fd = make_connect(4711,inet_addr("127.0.0.1"))) == -1) {
    printf("Fehler beim connecten!\n");
    exit(1);
  }

  count = read(fd,str,99);
  str[count] = '\0';

  printf("%s",str);
  
  close(fd);
}
